<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
        "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html><head><title>WP-Gatekeeper RC2 Update Script</title>
<style type="text/css" media="all">
body {font: 1em Georgia, Times, serif; padding: 1em 5em;}
h3 {margin-top: 2em;}
table {margin: 1em 0; border-top: 1px dotted;}
td {border-bottom: 1px dotted; padding: 0 0.5em;}
ul {margin: 0.25em 2em; padding: 0;}
p {margin: 1em 0 0;}
</style></head>
<body>
<h1>WP-Gatekeeper RC2 Update Script</h1>

<?php
/* =========================================================================
WordPress Gatekeeper
(cc) 2005  Eric A. Meyer  http://meyerweb.com/
========================================================================= */

require_once 'wp-config.php';

$tablechallenges = $table_prefix.'gatekeeper_challenges';
$date_append = 'j M Y - g:i:s a';

$wpdb->hide_errors();
$sql = "SELECT challenge, response, visible, date_added, date_modified FROM $tablechallenges ORDER BY ID";
$old_table = $wpdb->get_results($sql);
$old_number = count($old_table);
$rc1_table = get_option('gatekeeper_challenges');
$rc1_number = count($rc1_table);
$rc1_markup = get_option('gatekeeper_default_format');
$rc2_markup = get_option('gatekeeper_markup');

//$now = date('Y-m-d H:i:s');

if (!isset($_REQUEST["copy"]) && !isset($_REQUEST["update"]) && !isset($_REQUEST["dump"]) && !isset($_REQUEST["finish"])) {

	echo "<h3>Checking data...</h3>";
	$old_action = $rc1_action = '';
	if ($old_number || $old_number > 0) {
		echo "<p>Found WP-Gatekeeper 1.0b1 table containing $old_number challenge";
		echo $old_number != 1 ? 's' : '';
		echo ":</p><table>";
		foreach ($old_table as $entry) {
			$challenge = stripslashes($entry->challenge);
			$response = stripslashes($entry->response);
			echo "<tr><td>$challenge</td><td>$response</td></tr>";
		}
		echo '</table>';
		$old_action = 'You can choose to <a href="'.$PHP_SELF.'?copy=1">import the old data, <em>adding</em> it to any existing challenges you might already have created in 1.5 RC1 and updating everything to RC2</a>.  Duplicates, if any, will be ignored.';
	}

	if ($rc1_number || $rc1_number > 0) {
		echo "<p>Found WP-Gatekeeper 1.5 table containing $rc1_number challenge";
		echo $rc1_number != 1 ? 's' : '';
		echo ":</p><table>";
		foreach ($rc1_table as $entry) {
			$challenge = stripslashes($entry['challenge']);
			$response = stripslashes($entry['response']);
			echo "<tr><td>$challenge</td><td>$response</td></tr>";
		}
		echo '</table>';
		if ($old_action != '') {
			$rc1_action = 'You can choose to <a href="'.$PHP_SELF.'?update=1">dump any old 1.0b1 data and just update RC1 to RC2</a>.';
		} else {
			if ($rc1_markup) {
				$rc1_action = 'You can now <a href="'.$PHP_SELF.'?update=1">update RC1 to RC2</a>.';
			} else {
				$rc1_action = "It seems that you've already updated to RC2.  Thanks for using WP-Gatekeeper!";
			}
		}
	}
	echo "<h3>And now...</h3><ul>";
	if ($old_action) echo "<li>$old_action</li>";
	echo "<li>$rc1_action</li>";
	echo "</ul>";
}

if (isset($_REQUEST["copy"])) {
	$transfer = false;
	echo "<h3>Copying old data...</h3>";
	$ID = -1;
	foreach ($rc1_table as $check) {
		if ($check['ID'] > $ID) $ID = $check['ID'];
	}
	if ($ID < 0) die ('ID scan failed!');
	foreach ($old_table as $entry) {
		$duplicate = false;
		foreach ($rc1_table as $exists) {
			if ($entry->challenge == $exists['challenge'] && $entry->response == $exists['response']) {
				$duplicate = true;
			}
		}
		if (!$duplicate) {
			$transfer = true;
			$ID = $ID + 1;
			$newchallenge = array(
				"ID"=>$ID,
				"visible"=>$entry->visible,
				"challenge"=>$entry->challenge,
				"response"=>$entry->response,
				"date_added"=>$entry->date_added,
				"date_modified"=>$entry->date_modified
			);
			array_push($rc1_table,$newchallenge);
			echo "<p>1.0b1 challenge (".stripslashes($entry->challenge).") added with ID $ID.</p>";
		}
	}
	if ($transfer) {
		update_option('gatekeeper_challenges',$rc1_table);
	} else {
		echo '<p>All challenges duplicated; none copied.</p>';
	}
}

if (isset($_REQUEST["copy"]) || isset($_REQUEST["update"])) {
	rename_option();
	if ($old_table) {
		echo '<p>You are now ready to delete the old 1.0b1 tables.  You can skip this step, but doing so will mean that the old tables are kept in the database.</p><ul><li><a href="'.$PHP_SELF.'?dump=1">Delete the old tables</a></li><li><a href="'.$PHP_SELF.'?finish=1">Keep the old tables</a></li></ul>';
	}
}

if (isset($_REQUEST["dump"])) {
	$sql = 'DROP TABLE IF EXISTS ' . $table_prefix . 'gatekeeper_challenges';
	$wpdb->query($sql);
	echo 'Gatekeeper 1.0b1 tables deleted.';
}

if (isset($_REQUEST["dump"]) || isset($_REQUEST["finish"]) ||
	((isset($_REQUEST["copy"]) || isset($_REQUEST["update"])) && !$old_table) ) {
	echo "<hr/><p>Done!  You can now go about your life as if nothing untoward had happened.  Thanks for upgrading WP-Gatekeeper!</p>";
}


function rename_option() {
	global $wpdb, $cache_settings, $table_prefix;
	$table = $table_prefix . 'options';
	$opt_id = $wpdb->get_var("SELECT option_id FROM $table WHERE option_name = 'gatekeeper_default_format';");
	if ($opt_id) {
		echo "<p>Updating option #$opt_id</p>";
		$wpdb->query("UPDATE $table SET option_name = 'gatekeeper_markup' WHERE option_id = '$opt_id';");
	}
}

?>
</body>
</html>